diff --git a/ChangeLog b/ChangeLog
index fd37d8f..0f21896 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+2007-11-08  Jim Meyering  <meyering@redhat.com>
+
+	* src/virsh.c (vshPrintExtra, vshDebug): Use gcc's printf attribute.
+
 Thu Nov  8 17:06:50 CET 2007 Daniel Veillard <veillard@redhat.com>
 
 	* src/virsh.c: patch from Jim Meyering to correct vshCommandOptInt
diff --git a/src/virsh.c b/src/virsh.c
index 852dea2..5e0cfb8 100644
--- a/src/virsh.c
+++ b/src/virsh.c
@@ -254,8 +254,10 @@ static virNetworkPtr vshCommandOptNetworkBy(vshControl * ctl, vshCmd * cmd,
     vshCommandOptNetworkBy(_ctl, _cmd, _optname, _name,             \
                            VSH_BYUUID|VSH_BYNAME)
 
-static void vshPrintExtra(vshControl * ctl, const char *format, ...);
-static void vshDebug(vshControl * ctl, int level, const char *format, ...);
+static void vshPrintExtra(vshControl * ctl, const char *format, ...)
+    ATTRIBUTE_FORMAT(printf, 2, 3);
+static void vshDebug(vshControl * ctl, int level, const char *format, ...)
+    ATTRIBUTE_FORMAT(printf, 3, 4);
 
 /* XXX: add batch support */
 #define vshPrint(_ctl, ...)   fprintf(stdout, __VA_ARGS__)
